
Redmine - Defect #8628
"Related to" reference may yield circular dependency error message
2011-06-16 09:50 - Christian Zagrodnick

Status: Closed Start date: 2011-06-16
Priority: Normal Due date:
Assignee: Jean-Philippe Lang % Done: 0%
Category: Issues Estimated time: 0.00 hour
Target version: 3.3.0
Resolution: Fixed Affected version:
Description

The "related to" reference is neither directed nor declaring a dependency. Thus the error "This relation would create a circular
dependency" seems wrong. "Related to" references should be possible in any case, should they not?

Related issues:
Related to Redmine - Feature # 16818: Allow multiple relationships between tw... New
Related to Redmine - Defect # 13654: Can't set parent issue when issue relati... Closed
Duplicated by Redmine - Feature # 14660: Excluding "related to" relation from... Closed
Duplicated by Redmine - Defect # 13914: Circular dependency issue when issue ... Closed

History
#1 - 2011-06-26 17:08 - Jean-Baptiste Barth
- Category set to Issues
- Status changed from New to 7
- Assignee set to Jean-Baptiste Barth
- Target version set to Candidate for next major release

Agreed, definitely. I'll have a look at it since I already worked on issue relations today.

#2 - 2012-01-17 13:39 - Victor Engmark

"Related to" is reciprocal to itself. In other words, when such a relation is created, there should be a link from both issues to the other one of the
relation.

#3 - 2012-01-25 18:12 - Christian Zagrodnick

Victor Engmark wrote:

"Related to" is reciprocal to itself. In other words, when such a relation is created, there should be a link from both issues to the other one of the
relation.

That is the case but you could still want to build larger circles A -> B -> C -> A.

#4 - 2012-02-16 05:45 - Fares Abdullah

I had the same problem -
In my case I had an issue, A. I created issue B and set it as related to A. Then I found that B was a duplicate of an existing issue, C, that someone else
had created.

I marked B as a duplicate of C, and wanted to relate A to C, and got the "circular dependency" error. I had to manually go and delete the relation
between A and B to be able to relate A to C, even though it should not be necessary.

"related to" should allow many different issues related together, as it is not a "dependency".

Cheers and thanks for the great application!

#5 - 2012-06-10 22:42 - Jean-Baptiste Barth
- Assignee deleted (Jean-Baptiste Barth)

#6 - 2013-01-13 21:04 - Jean-Philippe Lang
- Status changed from 7 to New

Assigned issue with no assignee back to New status.

#7 - 2013-04-30 16:51 - Leandro Guida

Here we are having the same problem.

I have an issue A, which is "father" of the issues B and C. When I try to set that C follows B, it gives me the "circular dependency" message.

#8 - 2013-05-02 17:43 - Robin McKenzie

+1 "related to" isn't a dependency.

Having the same problem, since we upgraded to the latest version of Redmine.

I've had to advise all our devs to stop using the Related Issues functionality, as this is preventing us setting up tickets with parent/child relationships.

e.g. Create a parent ticket, and two child tickets of this.  Attempt to relate the two child tickets - "This relation would create a circular dependency".

Alternatively, create two tickets and relate them to each other.  Create another ticket, and then set child A to have this as its parent.  Attempt to set
child B to have the same parent - "Parent task is invalid".

Would it be possible to get a fix for this prioritised?

#9 - 2013-05-08 15:35 - Ralf S.

+1 for this ticket from our side to (using V2.3.1)

It would be very nice, if this fix would get high priority for the next release.

#10 - 2013-05-15 15:12 - Benjamin Roberts
+1 for this issue

Environment:
  Redmine version                          2.3.0.stable
  Ruby version                             1.9.3 (i386-mingw32)
  Rails version                            3.2.13
  Environment                              production
  Database adapter                         Mysql2
Redmine plugins:
  no plugin installed

#11 - 2013-07-23 14:53 - Luke Purdy

+1 for this update.

At the moment I can't create any parent "summary" tasks, for any children who have following dependencies between them (as 4).

It would be helpful if this fix is included as a high priority within the next release.

#12 - 2013-10-24 12:44 - Robin McKenzie

Would it be possible to get some feedback as to whether this is being considered for the next release?  It was originally set to "Candidate for next
major release" over two years ago...

#13 - 2014-03-24 08:27 - Akiko Takano

+1 for this update.

#14 - 2014-05-12 18:12 - Egbert van der Wal
- File fix_issue_relations.diff added

How can this still be open when it's such a simple fix?

I applied the attached patch to my Redmine SVN checkout to fix this. Feel free to merge it in. It basically takes the type of relations into account when
traversing them and ignores 'copied_to', 'duplicates' and 'relates' relationships as these do not imply any dependency.

#15 - 2014-05-12 18:14 - Egbert van der Wal
- File fix_issue_relations.diff added

Sorry, this was the incorrect patch. Attached is the correct version. Please remove the previous patch.

#16 - 2014-05-19 21:13 - Egbert van der Wal

Just a tiny update after reading the [[Patch]] page.

2020-09-26 3/6



The patch I submitted is against revision 13127 of the stable-2.5 branch. I just tested it against trunk, revision 13138 and it also applies cleanly.

#17 - 2014-06-30 06:55 - Toshi MARUYAMA
- Duplicated by Feature #14660: Excluding "related to" relation from circular dependency check added

#18 - 2014-06-30 06:59 - Toshi MARUYAMA
- Related to deleted (Defect #13914: Circular dependency issue when issue dependency is set)

#19 - 2014-06-30 06:59 - Toshi MARUYAMA
- Duplicated by Defect #13914: Circular dependency issue when issue dependency is set added

#20 - 2014-07-18 02:30 - James H

+1

#21 - 2014-08-28 15:45 - Uwe Koloska

What about the fix for #7320?  Shouldn't the tests for r4723 and r5104 detect the problem described here?

#22 - 2014-08-29 11:05 - Uwe Koloska

It looks like related to has a direction!

    -  create three tickets 1, 2, 3
    -  create relation 1 -> 2
    -  create relation 2 -> 3
    -  create relation 3 -> 1 gives the circular dependency error
    -  create relation 1 -> 3 succeeds
instead of related to you can also use in any combination:
    -  duplicates  (no error with duplicated by)
    -  copied to   (no error with copied from)

Since both are really meant to have a direction their's nothing wrong if there is a circle of all duplicates or copied to, but it should definitely not treat all
relations the same.

#23 - 2014-09-05 16:47 - Uwe Koloska
- File issue_relation_test.patch added

attached a test for the current 2.5 branch (but has not changed in trunk) that tests for the following dependencies that should both not be circular:
    -  1->2, 2->3, 3->1  (error)
    -  1->2, 2->3, 1->3  (no error)

#24 - 2014-10-24 13:12 - Etienne Rossignon

+1 to get a fix for this one

#25 - 2014-12-03 06:50 - Mischa The Evil
- Related to Feature #16818: Allow multiple relationships between two issues added

#26 - 2015-01-08 14:16 - Marco Shima

+1 to finally get this fixed. Redmine is only partially useful as long as this major bug exists.

#27 - 2015-05-27 12:54 - Anton Statutov

+1. This definitely needs to be fixed.

#28 - 2015-10-23 09:22 - Nayuta Taga

+1

#29 - 2015-11-17 10:08 - Jānis Elmeris

+1

#30 - 2016-01-12 10:38 - Go MAEDA

r15056 also seems to have fixed this issue.
Now I can make A->B, B->C, C->A relations on Redmine 3.2.0.devel.15056.

#31 - 2016-01-13 05:40 - Go MAEDA
- Status changed from New to Resolved
- Target version changed from Candidate for next major release to 3.3.0

Fixed by #13654.
I am setting target version to 3.3.0 because I think it would be better to list this important issue in Changelog.

#32 - 2016-01-13 06:04 - Go MAEDA
- Related to Defect #13654: Can't set parent issue when issue relations among child issues are present added

#33 - 2016-01-16 08:39 - Jean-Philippe Lang
- Status changed from Resolved to Closed
- Assignee set to Jean-Philippe Lang
- Resolution set to Fixed

Thanks.

#34 - 2016-05-17 13:17 - Robin McKenzie

Hi, any idea when 3.3.0 will be released?
Files
fix_issue_relations.diff 853 Bytes 2014-05-12 Egbert van der Wal
fix_issue_relations.diff 655 Bytes 2014-05-12 Egbert van der Wal
issue_relation_test.patch 1.82 KB 2014-09-05 Uwe Koloska
